/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_VOO                                                      */
/* Tabela : VOO                                                               */
/*                                                                            */
/* Criao:                                                                   */
/* 09/10/2003 Bruno Leonardo                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_VOO
BEFORE INSERT OR UPDATE OR DELETE
ON VOO FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUVOO := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUVOO := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('VOO', '', 'CDFILIAL='||:OLD.CDFILIAL||';CDCIA='||:OLD.CDCIA||';NRVOO='||:OLD.NRVOO||';',SYSDATE);
   END IF;
END;
/

ALTER TABLE VOO MODIFY DTULTATUVOO DEFAULT SYSDATE
/
