CREATE OR REPLACE TRIGGER LOG_GER_CODESPSUBTRI
AFTER UPDATE OR INSERT OR DELETE
ON CODESPSUBTRI FOR EACH ROW
DECLARE
  V_TIPO         VARCHAR2(1);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DESC         VARCHAR2(1000);
  V_ITPESQ       VARCHAR2(40);
  V_NMOPERADOR   VARCHAR2(40);
BEGIN
   /*IDTIPOOPER - '1' - Incluso, 
                  '2' - Alterao, 
                  '3' - Excluso*/

   V_TIPO       := '0';
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';

   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF DELETING THEN
      IF :OLD.CDSEGMENTO IS NOT NULL THEN
         V_DESC := V_DESC || ' CdSegmento=' || :OLD.CDSEGMENTO;
      END IF;

      IF :OLD.CDITEM IS NOT NULL THEN
         V_DESC := V_DESC || ' CdItem=' || :OLD.CDITEM;
      END IF;

      IF :OLD.CDCEST IS NOT NULL THEN
         V_DESC := V_DESC || ' CdCEST=' || :OLD.CDCEST;
      END IF;

      IF :OLD.CDNCMSHUTIL IS NOT NULL THEN
         V_DESC := V_DESC || ' CdNCMSHUtil=' || :OLD.CDNCMSHUTIL;
      END IF;

      IF :OLD.DSCEST IS NOT NULL THEN
         V_DESC := V_DESC || ' DsCEST=' || :OLD.DSCEST;
      END IF;

      V_TIPO   := '3';
      V_ITPESQ := :OLD.CDSEGMENTO||:OLD.CDITEM||:OLD.CDCEST;
   ELSE
      IF UPDATING THEN
         IF (NVL(:OLD.CDSEGMENTO,'!')  <> NVL(:NEW.CDSEGMENTO,'!'))  OR
            (NVL(:OLD.CDITEM,'!')      <> NVL(:NEW.CDITEM,'!'))      OR
            (NVL(:OLD.CDCEST,'!')      <> NVL(:NEW.CDCEST,'!'))      OR
            (NVL(:OLD.CDNCMSHUTIL,'!') <> NVL(:NEW.CDNCMSHUTIL,'!')) OR
            (NVL(:OLD.DSCEST,'!')      <> NVL(:NEW.DSCEST,'!'))      THEN

            IF NVL(:NEW.CDSEGMENTO, '!') <> NVL(:OLD.CDSEGMENTO, '!') THEN
               V_DESC := V_DESC||' CdSegmento='  || :NEW.CDSEGMENTO;
            END IF;

            IF NVL(:NEW.CDITEM, '!') <> NVL(:OLD.CDITEM, '!') THEN
               V_DESC := V_DESC||' CdItem='  || :NEW.CDITEM;
            END IF;

            IF NVL(:NEW.CDCEST, '!') <> NVL(:OLD.CDCEST, '!') THEN
               V_DESC := V_DESC||' CdCEST='  || :NEW.CDCEST;
            END IF;

            IF :NEW.CDNCMSHUTIL <> :OLD.CDNCMSHUTIL THEN
               V_DESC := V_DESC||' CdNCMSHUtil='  || :NEW.CDNCMSHUTIL;
            END IF;

            IF :NEW.DSCEST <> :OLD.DSCEST THEN
               V_DESC := V_DESC||' DsCEST='  || :NEW.DSCEST;
            END IF;

            V_TIPO   := '2';
            V_ITPESQ := :OLD.CDSEGMENTO||:OLD.CDITEM||:OLD.CDCEST;
         END IF;
      ELSE
         IF NVL(:NEW.CDSEGMENTO, '!') <> NVL(:OLD.CDSEGMENTO, '!') THEN
            V_DESC := V_DESC||' CdSegmento='  || :NEW.CDSEGMENTO;
         END IF;

         IF NVL(:NEW.CDITEM, '!') <> NVL(:OLD.CDITEM, '!') THEN
            V_DESC := V_DESC||' CdItem='  || :NEW.CDITEM;
         END IF;

         IF NVL(:NEW.CDCEST, '!') <> NVL(:OLD.CDCEST, '!') THEN
            V_DESC := V_DESC||' CdCEST='  || :NEW.CDCEST;
         END IF;

         IF NVL(:NEW.CDNCMSHUTIL, '!') <> NVL(:OLD.CDNCMSHUTIL, '!') THEN
            V_DESC := V_DESC||' CdNCMSHUtil='  || :NEW.CDNCMSHUTIL;
         END IF;

         IF NVL(:NEW.DSCEST, '!') <> NVL(:OLD.DSCEST, '!') THEN
            V_DESC := V_DESC||' DsCEST='  || :NEW.DSCEST;
         END IF;

         V_TIPO   := '1';
         V_ITPESQ := :NEW.CDSEGMENTO||:NEW.CDITEM||:NEW.CDCEST;
      END IF;
   END IF;

   V_DESC := SUBSTR(V_DESC, 1, 600);

   IF V_TIPO <> '0' THEN
      IF NOT V_DESC IS NULL THEN
         INSERT INTO LOGOPERA
            (NMTABELA,
             DTOPERACAO,
             NMRESPOPER,
             IDTIPOOPER,
             DSOPERACAO,
             CDPESQITEM,
             DSRDMUSUOPER,
             DSENDUSUOPER,
             DSNMUSUOPER,
             DSMETUSUOPER,
             CDORESPOPER)
         VALUES
            ('CODESPSUBTRI',
             SYSDATE,
             NVL(V_NMOPERADOR,' '),
             V_TIPO,
             V_DESC,
             V_ITPESQ,
             V_DSSERVERRDM,
             V_DSREMOTEADDR,
             V_DSREMOTEHOST,
             V_DSSERVMETHOD,
             V_DSREMOTEOPER);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_CODESPSUBTRI','6.10.xxx'); END;
/
