/* Procedure para gerar contas a receber*/
create or replace PROCEDURE GERA_CONTA(
   P_IDENTRSAID   IN NOTAFISCAL.IDENTRSAIDOP%TYPE,
   P_CDEMPRESA    IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDFILIAL     IN NOTAFISCAL.CDFILIAL%TYPE,
   P_FILIORIGEM   IN NOTAFISCAL.CDFILIAL%TYPE,
   P_NRLANCTONF   IN NOTAFISCAL.NRLANCTONF%TYPE,
   P_NRLANBOL     IN BOLETRECEBER.NRLANBOLREC%TYPE,
   P_VALORDOC     IN NOTAFISCAL.VRNOTAFISC%TYPE,
   P_CDTIPOOPER   IN NOTAFISCAL.CDTIPOOPER%TYPE,
   P_CDSERIE      IN NOTAFISCAL.CDSERIE%TYPE,
   P_IDORIGDEST   IN NOTAFISCAL.IDORIGDESTNF%TYPE,
   P_CDCLIEFORN   IN NOTAFISCAL.CDCLIENTE%TYPE,
   P_DTEMISSAO    IN DATE,
   P_DTENTRSAID   IN DATE,
   P_STATUSNF     IN NOTAFISCAL.IDSTATUS%TYPE,
   P_CDVENDEDOR   IN NOTAFISCAL.CDVENDEDOR%TYPE,
   P_DTLANCNF     IN NOTAFISCAL.DTLANCAMENNF%TYPE,
   P_DTVENCCONTA  IN DATE,
   P_CDTIPORECE   IN TIPORECE.CDTIPORECE%TYPE,
   P_DESCCONTA    IN TIPOCTRECEBER.DSTPCTRECEB%TYPE,
   P_NRCHEQUEVEND IN MOVCAIXA.NRCHEQUEVEND%TYPE,
   P_CDBANCHEQVEN IN MOVCAIXA.CDBANCHEQVEN%TYPE,
   P_CDAGECHEQVEN IN MOVCAIXA.CDAGECHEQVEN%TYPE,
   P_CDCNTCHEQVEN IN MOVCAIXA.CDCNTCHEQVEN%TYPE,
   P_NRINSJURCHEQ IN MOVCAIXA.NRINSJURCHEQ%TYPE,
   P_IDSTATCONTA  IN CONTAPAGAR.IDSTATPAG%TYPE,
   P_CDTPAJUSTE   IN AJCTPAGAR.CDAJUCTPAG%TYPE,
   P_VRAJUSTE     IN AJCTPAGAR.VRAJUSTEPAG%TYPE,
   P_CDOPERADOR   IN BAIXARECEBIDA.CDOPERADOR%TYPE,
   P_QTPARCELAS   IN FLOAT)
AS
  V_CDINSCMUNI    NOTAFISCAL.CDINSCMUNI%TYPE;
  V_CDINSCESTA    NOTAFISCAL.CDINSCESTA%TYPE;
  V_CDCLASSFINA   CLASSFINANC.CDCLASSFINA%TYPE;
  V_NRLANCCONT    VARCHAR2(20);
  V_CDTIPOCONTA   CONTARECEBER.CDTPCTRECEB%TYPE;
  V_DSTPCTRECEB   TIPOCTRECEBER.DSTPCTRECEB%TYPE;
  V_DESCCONTA     TIPOCTRECEBER.DSTPCTRECEB%TYPE;
  V_VRPEMULTA     CLIENTE.VRPEMORBCLI%TYPE;
  V_VRPEMORA      CLIENTE.VRPEMULBCLI%TYPE;
  V_NRDOCUMENTO   NOTAFISCAL.NRNOTAFISC%TYPE;
  V_COUNT         FLOAT;
  V_VRCONTA       FLOAT;
  V_VRACUMCONTA   FLOAT;
  V_VRAJUSTE      FLOAT;
  V_VRACUMAJUSTE  FLOAT;
  V_DTVENC        DATE;
  V_QTPARCELAS    FLOAT;
  V_NRLANBOL      VARCHAR2(10);
BEGIN
   BEGIN
      SELECT MAX(CDINSCMUNI), MAX(CDINSCESTA)
      INTO V_CDINSCMUNI, V_CDINSCESTA
      FROM FILIAL
      WHERE CDFILIAL = P_FILIORIGEM;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN V_CDINSCMUNI := ''; V_CDINSCESTA := '';
   END;

   BEGIN
      SELECT MAX(TR.CDTPCTRECEB), MAX(TC.DSTPCTRECEB)
      INTO V_CDTIPOCONTA, V_DESCCONTA
      FROM TIPORECE TR, TIPOCTRECEBER TC
      WHERE TR.CDTIPORECE = P_CDTIPORECE AND
            TR.CDTPCTRECEB = TC.CDTPCTRECEB;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN V_CDTIPOCONTA := '';
   END;
   IF V_CDTIPOCONTA IS NOT NULL THEN
      IF P_DESCCONTA IS NOT NULL THEN
         V_DESCCONTA := P_DESCCONTA;
      END IF;

      /*BUSCA PARAMETRIZAO DE MULTA E MORA*/
      BEGIN
         SELECT MAX(VRPEMULBCLI), MAX(VRPEMORBCLI)
         INTO V_VRPEMULTA, V_VRPEMORA
         FROM CLIENTE
         WHERE CDCLIENTE = P_CDCLIEFORN;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            BEGIN
               SELECT MAX(VRPEMULEMPR), MAX(VRPEMOREMPR)
               INTO V_VRPEMULTA, V_VRPEMORA
               FROM EMPRESA
               WHERE (CDEMPRESA = P_CDEMPRESA);
            EXCEPTION
               WHEN NO_DATA_FOUND THEN V_VRPEMULTA := 0; V_VRPEMORA := 0;
            END;
      END;
      /*BUSCA CLASSIFICAO FINANCEIRA DO TIPO DE CONTA*/
      BEGIN
         SELECT MAX(CDCLASSFINA)
         INTO V_CDCLASSFINA
         FROM TIPOCTRECEBER
         WHERE CDTPCTRECEB = V_CDTIPOCONTA;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN V_CDCLASSFINA := '';
      END;
      V_NRLANBOL := P_NRLANBOL;
      /*BUSCA O NMERO DO LANAMENTO CONTBIL*/
      NOVO_CODIGO('LANCCONTABIL' || P_CDEMPRESA || TO_CHAR(P_DTEMISSAO,'YYYYMM'), V_NRLANCCONT);
      V_NRLANCCONT := SUBSTR(V_NRLANCCONT, 9, 12);

      /*BUSCA O NMERO DO DOCUMENTO*/
      NOVO_CODIGO('NRNOTAFISCREC', V_NRDOCUMENTO);
      V_NRDOCUMENTO := SUBSTR(V_NRDOCUMENTO, 14, 7);

      /*INCLUI O DOCUMENTO*/
      INCLUI_NOTA(P_IDENTRSAID, P_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI, P_CDFILIAL, P_NRLANCTONF,
                  P_FILIORIGEM, P_VALORDOC, P_CDTIPOOPER, P_IDORIGDEST, P_CDCLIEFORN, V_NRDOCUMENTO,
                  P_CDSERIE, P_DTEMISSAO, P_DTENTRSAID, '', P_CDVENDEDOR, '',
                  P_STATUSNF, P_DTLANCNF);

      /*SOMA DOS VALORES DE TODAS AS CONTAS LANADAS (PARA VERIFICAR DIVERGNCIAS DE VALORES)*/
      V_VRACUMCONTA := 0;
      /*SOMA DOS VALORES DE TODOS OS AJUSTES LANADOS (PARA VERIFICAR DIVERGNCIAS DE VALORES)*/
      V_VRACUMAJUSTE := 0;
      /*VALOR DE CADA CONTA*/
      V_VRCONTA := ROUND(P_VALORDOC/P_QTPARCELAS, 2);
      /*VALOR DE CADA AJUSTE*/
      V_VRAJUSTE := ROUND(P_VRAJUSTE/P_QTPARCELAS, 2);
      /*DATA DE VENCIMENTO*/
      V_DTVENC := P_DTVENCCONTA;

      V_COUNT := 1;
      /*GERA O NMERO DE CONTAS INDICADO PELO PARMETRO QTPARCELAS*/
      WHILE (V_COUNT <= P_QTPARCELAS) LOOP
         /*ACUMULAO DE VALORES*/
         V_VRACUMCONTA := V_VRACUMCONTA + V_VRCONTA;
         V_VRACUMAJUSTE := V_VRACUMAJUSTE + V_VRAJUSTE;

         /*JOGA AS DIFERENAS PARA A LTIMA PARCELA*/
         IF (V_COUNT + 1 > P_QTPARCELAS) THEN
            V_VRCONTA := V_VRCONTA + (P_VALORDOC - V_VRACUMCONTA);
            V_VRAJUSTE := V_VRAJUSTE + (P_VRAJUSTE - V_VRACUMAJUSTE);
         END IF;
         /*GERA O BOLETO DA CONTA*/
         GERA_BOLETOS_REC(V_NRLANBOL, P_CDFILIAL, P_CDCLIEFORN,
                          P_CDEMPRESA, V_VRCONTA, V_DTVENC,
                          P_CDTIPORECE, P_NRCHEQUEVEND, P_CDBANCHEQVEN,
                          P_CDAGECHEQVEN, P_CDCNTCHEQVEN);
         /*ATUALIZA O FLUXO DE CAIXA DA CONTA*/
         ATUALIZA_FLUXO_DE_CAIXA(P_CDEMPRESA,
                                 P_CDFILIAL,
                                 V_DTVENC,
                                 'E',
                                 V_CDCLASSFINA,
                                 V_VRCONTA - V_VRAJUSTE,
                                 0);
         /*INCLUI A CONTA A RECEBER*/
         INCLUI_CONTA(P_IDENTRSAID, P_CDEMPRESA, P_CDFILIAL, P_NRLANCTONF,
                      LPAD(TO_CHAR(V_COUNT), 2, '0'), V_VRCONTA, V_DTVENC,
                      V_DESCCONTA, V_CDTIPOCONTA,
                      0, '00', P_IDSTATCONTA,
                      V_CDCLASSFINA, V_NRLANBOL);
         /*GERA O AJUSTE DA CONTA A RECEBER*/
         IF (P_CDTPAJUSTE IS NOT NULL) AND (V_VRAJUSTE <> 0) THEN
            /*INSERE O AJUSTE*/
            INSERT INTO AJCTRECEBER
                  (CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC, DTAJUSTEREC, CDAJUCTREC,
                   DSAJUSTEREC, VRAJUSTEREC, CDCLASSFINA, CDEMMFAJCNTR, CDFIMFAJCNTR,
                   DTMOVFLUXO, IDMOVFLUXO, CDECTBAJREC, NRLCTBAJREC)
            VALUES
                  (P_CDFILIAL, P_NRLANCTONF, LPAD(TO_CHAR(V_COUNT), 2, '0'), '00', V_DTVENC, P_CDTPAJUSTE,
                   'Ajuste', V_VRAJUSTE, V_CDCLASSFINA, P_CDEMPRESA, P_CDFILIAL,
                   V_DTVENC, 'E', '', '');
            /*ATUALIZA O VALOR DA CONTA COM O AJUSTE GERADO*/
            UPDATE CONTARECEBER
               SET VRATUAREC = VRATUAREC - V_VRAJUSTE
             WHERE CDFILIAL = P_CDFILIAL
               AND NRLANCTONF = P_NRLANCTONF
               AND NRSEQVENREC = LPAD(TO_CHAR(V_COUNT), 2, '0')
               AND NRPARCELAREC = '00';
            /*ATUALIZA O VALOR DO BOLETO COM O AJUSTE GERADO*/
            UPDATE BOLETRECEBER
               SET VRFINALBREC = VRFINALBREC - V_VRAJUSTE,
                   VRBOLREC = VRBOLREC - V_VRAJUSTE
             WHERE CDFILIAL = P_CDFILIAL
               AND NRLANBOLREC = V_NRLANBOL;
            /*ATUALIZA VALOR DO TIPO DE RECEBIMENTO DO BOLETO*/
            UPDATE TPRECBOLETO
               SET VRTPRECBOLR = VRTPRECBOLR - V_VRAJUSTE
             WHERE CDFILIAL = P_CDFILIAL
               AND NRLANBOLREC = V_NRLANBOL
               AND NRSEQTPRECBO = '01';
         END IF;

         /*GERA O RATEIO DA CONTA*/
         GERA_RATEIO_CONTA(P_IDENTRSAID, P_CDFILIAL, P_NRLANCTONF, LPAD(TO_CHAR(V_COUNT), 2, '0'),
                           '00', V_VRCONTA - V_VRAJUSTE, V_CDTIPOCONTA, P_FILIORIGEM);

         /*VENCIMENTO DA PRXIMA CONTA*/
         V_DTVENC := ADD_MONTHS(V_DTVENC, 1);

         V_COUNT := V_COUNT + 1;
         /*ATUALIZA O NMERO PARA O PRXIMO BOLETO*/
         V_NRLANBOL := LPAD(TO_CHAR(TO_NUMBER(V_NRLANBOL) + 1), 10, '0');
      END LOOP;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_CONTA','5.25.xxx'); END;
/

